"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _graphqlGen = require("../../graphqlGen");

var _Button = _interopRequireDefault(require("../Button"));

var _styles = require("./styles");

var _core = require("@emotion/core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function buildUrlFromString(urlString) {
  if (!urlString.startsWith("http") || !urlString.startsWith("https")) {
    urlString = `http://${urlString}`;
  }

  var url = new URL(urlString);
  return url;
}

const ImportInput = ({
  models,
  context
}) => {
  const [importUrl, setImportUrl] = (0, _react.useState)('https://graphqlpokemon.favware.tech/');
  const [folderName, setFolderName] = (0, _react.useState)('catch_em_all');
  const [baseUrl, setBaseUrl] = (0, _react.useState)('https://graphqlpokemon.favware.tech/');
  const [baseUrlTouched, setBaseUrlTouched] = (0, _react.useState)(false);
  let driver = new _graphqlGen.GraphQlGenDrivers();
  (0, _react.useEffect)(() => {
    async function load() {
      load();
    }
  }, []);

  const handleBaseUrlChange = newValue => {
    setBaseUrlTouched(true);
    setBaseUrl(newValue);
  };

  const handleImportUrlChange = newValue => {
    if (baseUrlTouched === false) {
      setBaseUrl(newValue);
    }

    setImportUrl(newValue);
  };

  const handleSave = (0, _react.useCallback)(() => {
    async function execute() {
      var url;

      try {
        url = buildUrlFromString(importUrl);
      } catch {
        url = null;
      }

      try {
        driver.generateGraphQlFromUrl(context, models, folderName, baseUrl, url);
      } catch (e) {
        console.error(e);
        await this.props.context.app.alert('Error!', 'Something went wrong.');
      }
    }

    execute();
  }, [importUrl, folderName, baseUrl]);
  return (0, _core.jsx)("form", null, (0, _core.jsx)("div", {
    className: "form-control form-control--outlined"
  }, (0, _core.jsx)("label", null, "Import URL:", (0, _core.jsx)("input", {
    value: importUrl,
    placeholder: "{}",
    onChange: event => handleImportUrlChange(event.target.value)
  })), (0, _core.jsx)("label", null, "Folder Name:", (0, _core.jsx)("input", {
    value: folderName,
    placeholder: "{}",
    onChange: event => setFolderName(event.target.value)
  })), (0, _core.jsx)("label", null, "Generated Request Base URL:", (0, _core.jsx)("input", {
    value: baseUrl,
    placeholder: "{}",
    onChange: event => handleBaseUrlChange(event.target.value)
  }))), (0, _core.jsx)("div", {
    css: _styles.actionsContainerStyle
  }, (0, _core.jsx)(_Button.default, {
    label: "Cancel",
    closeModal: true
  }), (0, _core.jsx)(_Button.default, {
    label: "Submit",
    onClick: handleSave,
    closeModal: true
  })));
};

var _default = ImportInput;
exports.default = _default;